Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 108928)
@@ -1101,5 +1101,5 @@
     sltRetranslateUI();
     updateModelColumVisibilityCache();
-    uiCommon().setHelpKeyword(this, "vm-activity-overview" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "tk_vm-activity-overview" /* help keyword */);
     connect(&uiCommon(), &UICommon::sigAskToCommitData,
             this, &UIVMActivityOverviewWidget::sltSaveSettings);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 108928)
@@ -1083,5 +1083,5 @@
     , m_enmEmbedding(enmEmbedding)
 {
-    uiCommon().setHelpKeyword(this, "vm-activity-session-information" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "tk_vm-activity-session-information" /* help keyword */);
     setContextMenuPolicy(Qt::CustomContextMenu);
     connect(this, &UIVMActivityMonitor::customContextMenuRequested,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp	(revision 108928)
@@ -58,5 +58,5 @@
     , m_pMonitorContainer(0)
 {
-    uiCommon().setHelpKeyword(this, "vm-activity-session-information" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "tk_vm-activity-session-information" /* help keyword */);
     prepare();
     prepareActions();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 108928)
@@ -578,5 +578,5 @@
 
     /* Set help keyowrd for context sensitive help: */
-    uiCommon().setHelpKeyword(this, "cloud-using-cloud-profile-manager" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "tk_using-cloud-profile-manager" /* help keyword */);
 
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 108928)
@@ -374,5 +374,5 @@
 {
     /* Prepare self: */
-    uiCommon().setHelpKeyword(this, "extensions" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_extensions" /* help keyword */);
 
     /* Prepare stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 108928)
@@ -144,5 +144,5 @@
     restorePanelVisibility();
     UIFileManagerOptions::create();
-    uiCommon().setHelpKeyword(this, "guestadd-gc-file-manager" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_guestadd-gc-file-manager" /* help keyword */);
 
     if (!comMachine.isNull())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 108928)
@@ -690,5 +690,5 @@
             this, &UIVMLogViewerWidget::sltRetranslateUI);
 
-    uiCommon().setHelpKeyword(this, "log-viewer" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_log-viewer" /* help keyword */);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp	(revision 108928)
@@ -226,5 +226,5 @@
 
     /* Assign Help keyword: */
-    uiCommon().setHelpKeyword(this, "Introduction" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_about-virtualbox" /* help keyword */);
 
     /* Translate finally: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 108928)
@@ -62,5 +62,5 @@
 
     /* Configure context-sensitive help: */
-    uiCommon().setHelpKeyword(this, "settings-window" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_settings-window" /* help keyword */);
 
     /* Init model finally: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 108928)
@@ -267,5 +267,5 @@
         if (m_pButtonBox)
         {
-            uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-floppy-disk-image" /* help keyword */);
+            uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "tk_create-floppy-disk-image" /* help keyword */);
             connect(m_pButtonBox, &QDialogButtonBox::accepted, this, &UIFDCreationDialog::accept);
             connect(m_pButtonBox, &QDialogButtonBox::rejected, this, &UIFDCreationDialog::reject);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 108928)
@@ -758,5 +758,5 @@
             sltHandleMediumEnumerationFinish();
     }
-    uiCommon().setHelpKeyword(this,"virtual-media-manager" /* help keyword */);
+    uiCommon().setHelpKeyword(this,"ct_virtual-media-manager" /* help keyword */);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 108928)
@@ -838,5 +838,5 @@
 
 
-    uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-optical-disk-image" /* help keyword */);
+    uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "tk_create-optical-disk-image" /* help keyword */);
 
     sltRetranslateUI();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 108928)
@@ -1720,5 +1720,5 @@
 {
     /* Prepare self: */
-    uiCommon().setHelpKeyword(this, "config-network" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "tk_config-network" /* help keyword */);
 
     /* Prepare stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 108928)
@@ -524,5 +524,5 @@
         connect(pButtonBox, &QIDialogButtonBox::accepted, this, &UIVMCloseDialog::accept);
         connect(pButtonBox, &QIDialogButtonBox::rejected, this, &UIVMCloseDialog::reject);
-        uiCommon().setHelpKeyword(pButtonBox->button(QIDialogButtonBox::Help), "intro-save-machine-state" /* help keyword */);
+        uiCommon().setHelpKeyword(pButtonBox->button(QIDialogButtonBox::Help), "ct_intro-save-machine-state" /* help keyword */);
         connect(pButtonBox->button(QIDialogButtonBox::Help), &QPushButton::pressed,
                 pButtonBox, &QIDialogButtonBox::sltHandleHelpRequest);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 108928)
@@ -276,5 +276,5 @@
         /* Configure button-box: */
         m_pButtonBox->setStandardButtons(QDialogButtonBox::Close | QDialogButtonBox::Help);
-        uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "vm-activity-session-information" /* help keyword */);
+        uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "tk_vm-activity-session-information" /* help keyword */);
         connect(m_pButtonBox, &QIDialogButtonBox::rejected, this, &UIVMInformationDialog::sigClose);
         connect(m_pButtonBox->button(QDialogButtonBox::Help), &QPushButton::pressed,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 108928)
@@ -198,5 +198,5 @@
                     addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -207,5 +207,5 @@
                     addItem(":/keyboard_32px.png", ":/keyboard_24px.png", ":/keyboard_16px.png",
                             iPageIndex, "#input", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -217,5 +217,5 @@
                     addItem(":/refresh_32px.png", ":/refresh_24px.png", ":/refresh_16px.png",
                             iPageIndex, "#update", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -227,5 +227,5 @@
                     addItem(":/site_32px.png", ":/site_24px.png", ":/site_16px.png",
                             iPageIndex, "#language", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -236,5 +236,5 @@
                     addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -246,5 +246,5 @@
                     addItem(":/proxy_32px.png", ":/proxy_24px.png", ":/proxy_16px.png",
                             iPageIndex, "#proxy", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "tk_preferences" /* help keyword */);
                     break;
                 }
@@ -631,5 +631,5 @@
                     addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "generalsettings" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_generalsettings" /* help keyword */);
                     break;
                 }
@@ -640,5 +640,5 @@
                     addItem(":/chipset_32px.png", ":/chipset_24px.png", ":/chipset_16px.png",
                             iPageIndex, "#system", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-system" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_settings-system" /* help keyword */);
                     break;
                 }
@@ -649,5 +649,5 @@
                     addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-display" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_settings-display" /* help keyword */);
                     break;
                 }
@@ -658,5 +658,5 @@
                     addItem(":/hd_32px.png", ":/hd_24px.png", ":/hd_16px.png",
                             iPageIndex, "#storage", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-storage" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_settings-storage" /* help keyword */);
                     break;
                 }
@@ -667,5 +667,5 @@
                     addItem(":/sound_32px.png", ":/sound_24px.png", ":/sound_16px.png",
                             iPageIndex, "#audio", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-audio" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_settings-audio" /* help keyword */);
                     break;
                 }
@@ -676,5 +676,5 @@
                     addItem(":/nw_32px.png", ":/nw_24px.png", ":/nw_16px.png",
                             iPageIndex, "#network", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-network" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_settings-network" /* help keyword */);
                     break;
                 }
@@ -685,5 +685,5 @@
                     addItem(":/serial_port_32px.png", ":/serial_port_24px.png", ":/serial_port_16px.png",
                             iPageIndex, "#serialPorts", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "serialports" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_serialports" /* help keyword */);
                     break;
                 }
@@ -694,5 +694,5 @@
                     addItem(":/usb_32px.png", ":/usb_24px.png", ":/usb_16px.png",
                             iPageIndex, "#usb", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "usb-support" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_usb-support" /* help keyword */);
                     break;
                 }
@@ -712,5 +712,5 @@
                     addItem(":/interface_32px.png", ":/interface_24px.png", ":/interface_16px.png",
                             iPageIndex, "#userInterface", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "user-interface" /* help keyword */);
+                    addPageHelpKeyword(iPageIndex, "ct_user-interface" /* help keyword */);
                     break;
                 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 108928)
@@ -1328,5 +1328,5 @@
 
     /* Register help topic: */
-    uiCommon().setHelpKeyword(this, "snapshots" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_snapshots" /* help keyword */);
 
     /* Apply language settings: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 108928)
@@ -3988,5 +3988,5 @@
     loadSettings();
     configure();
-    uiCommon().setHelpKeyword(this, "soft-keyb" /* help keyword */);
+    uiCommon().setHelpKeyword(this, "ct_soft-keyb" /* help keyword */);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 108928)
@@ -49,5 +49,5 @@
                              const QString &strDefaultPath,
                              qulonglong uDefaultSize)
-    : UINativeWizard(pParent, WizardType_NewVD, "create-virtual-hard-disk-image" /* help keyword */)
+    : UINativeWizard(pParent, WizardType_NewVD, "tk_create-virtual-hard-disk-image" /* help keyword */)
     , m_strDefaultName(strDefaultName)
     , m_strDefaultPath(strDefaultPath)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 108927)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 108928)
@@ -66,5 +66,5 @@
                              const QString &strMachineGroup,
                              const QString &strISOFilePath /* = QString() */)
-    : UINativeWizard(pParent, WizardType_NewVM, "create-vm" /* help keyword */)
+    : UINativeWizard(pParent, WizardType_NewVM, "tk_create-vm" /* help keyword */)
     , m_strMachineGroup(strMachineGroup)
     , m_iIDECount(0)
@@ -107,11 +107,11 @@
         case WizardMode_Basic:
         {
-            UIWizardNewVMNameOSTypePage *pNamePage = new UIWizardNewVMNameOSTypePage("create-vm-name-os" /* help keyword*/);
+            UIWizardNewVMNameOSTypePage *pNamePage = new UIWizardNewVMNameOSTypePage("tk_create-vm-name-os" /* help keyword*/);
             addPage(pNamePage);
             if (!m_strInitialISOFilePath.isEmpty())
                 pNamePage->setISOFilePath(m_strInitialISOFilePath);
-            m_iUnattendedInstallPageIndex = addPage(new UIWizardNewVMUnattendedPage("create-vm-unattended-install" /* help keyword */));
+            m_iUnattendedInstallPageIndex = addPage(new UIWizardNewVMUnattendedPage("tk_create-vm-unattended-install" /* help keyword */));
             setUnattendedPageVisible(false);
-            addPage(new UIWizardNewVMHardwarePage("create-vm-hardware" /* help keyword*/));
+            addPage(new UIWizardNewVMHardwarePage("tk_create-vm-hardware" /* help keyword*/));
             addPage(new UIWizardNewVMSummaryPage);
             break;